#!/usr/bin/env python2

import subprocess

data_list = ['kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'splice_site_t_0_1', 'rcv1_test']

datas_path_dict = {\
'avazu-app':'./data/avazu-app',\
'criteo':'./data/criteo.tr.svm', \
'eps':'./data/epsilon_normalized', \
'higgs':'./data/HIGGS', \
'kdda':'./data/kdda',\
'kdd12':'./data/kdd12', \
'rcv1_test':'./data/rcv1_test', \
'url':'./data/url_combined', \
'web_trigram':'./data/webspam_wc_normalized_trigram',\
'splice_site_t_0_1':'./data/splice_site.t.0.1'
}

c = 1

def cal_nnza_nnzb(data_path, threshold):
    nnz_list = []
    for line in open(data_path):
        if line.startswith('dense') or line.startswith('sparse'): continue
        if 'nonzeros' in line:
            line = line.split()
            num_feat = int(line[-1].split('/')[0])
            ttl_num_feat = int(line[-1].split('/')[1])
        else:
            line = line.split()
        if len(line) != 2: continue

        nnz_list.append(int(line[-1]))

    ttl_nnz = sum(nnz_list)

    nnz_list = sorted(nnz_list)

    sum_nnz = 0
    for count, nnz in enumerate(nnz_list[::-1]):
        sum_nnz += nnz

        if sum_nnz*1.0/ttl_nnz > threshold:
            return (num_feat, ttl_num_feat, nnz)

dir_suffix = 'nnza.nnzb.log'
for data in data_list:
    for s in [5]:
        data_path = '{data}.{suffix}/{data}-{c}-log-{s}'.format(s=s, c=1, data_path=datas_path_dict[data], data=data, suffix = dir_suffix)
        print data_path
        num_feat, ttl_num_feat, nnza = cal_nnza_nnzb(data_path, 0.5)
        num_feat, ttl_num_feat, nnzb = cal_nnza_nnzb(data_path, 0.8)
        print(data, nnza, nnzb, num_feat, ttl_num_feat)
