#!/usr/bin/env python3

import subprocess, sys

cores_list_1 = [8, 1]
cores_list_2 = [4, 2]

if int(sys.argv[1]) == -1:
    data_list = ['heart_scale']
elif int(sys.argv[1]) == 0:
    data_list = ['rcv1_test']
else:
    data_list = ['kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'split_site_t_0_1', 'rcv1_test']

datas_path_dict = {\
'heart_scale':'./data/heart_scale', \
'criteo':'./data/criteo', \
'rcv1_test':'./data/rcv1_test', \
'yk':'./data/leisure', \
'eps':'./data/epsilon_normalized', \
'higgs':'./data/HIGGS', \
'kdd12':'./data/kdd12', \
'url':'./data/url_combined', \
'web_trigram':'./data/webspam_wc_normalized_trigram',\
'avazu-app':'./data/avazu-app',\
'kdda':'./data/kdda',\
'split_site_t_0_1':'./data/split_site.t.0.1'
}

method_path_dict = {\
'newglment_lr':'./codes/liblinear-2.11-omp'
}

methods_list = ['newglment_lr']

def run(cmd):
    print(cmd)
    subprocess.call(cmd, shell=True)

log_dir_suffix = 'newglmnet.speedup.log'

for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for core in cores_list_1:
        for method in methods_list:
            cmd = '{method_dir}/train -s 6 -m 500 -e 0.001 -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix)
            run(cmd)

for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for core in cores_list_2:
        for method in methods_list:
            cmd = '{method_dir}/train -s 6 -m 500 -e 0.001 -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix)
            run(cmd)
