import os, sys

def conv_e(num):
    return '{:.1e}'.format(num)

def conv(num):
    return '{:,}'.format(num)

def print_tex(data, log_list):
    print '\\hline'
    print "\multirow{0}{{*}}{1}".format(2, data_mapping[data]),

    print '&\#features&{0}'.format('&'.join(map(conv_e, log_list[1]))),
    print '\\\\'

    print '&$\\overline{{\\text{{{{\#updates}}}}}}$&{0}'.format('&'.join(map(conv, log_list[2]))),
    print '\\\\'


def binning(input_path, num_bin):
    out1 = []
    out2 = []
    out3 = []

    ttl_nnz = 0
    count_list = []
    nnz_list = []
    for line in open(input_path):
        nnz, count, tag = map(int, line.strip().split())
        count_list.append(count)
        nnz_list.append(nnz)

        ttl_nnz += nnz


    ttl_nnz_in_bin = 0
    ttl_count_in_bin = 0
    num = 0
    left_nnz = ttl_nnz
    avg_elements = int(left_nnz*1.0/num_bin)

    for (nnz, count) in zip(nnz_list, count_list):
        ttl_nnz_in_bin += nnz
        ttl_count_in_bin += count
        num += 1

        if ttl_nnz_in_bin >= avg_elements:
#            print ttl_nnz_in_bin, ttl_nnz_in_bin*1.0/num, ttl_count_in_bin*1.0/num
            if num_bin != 0:
                num_bin -= 1

            if num_bin <= 0:
                continue

            out1.append(ttl_nnz_in_bin/num)
            out2.append(num)
            out3.append(ttl_count_in_bin/num)
            left_nnz = left_nnz - ttl_nnz_in_bin
            avg_elements = int(left_nnz*1.0/num_bin)

            ttl_nnz_in_bin = 0
            ttl_count_in_bin = 0
            num = 0
    if num_bin == 0:
        out1.append(ttl_nnz_in_bin/num)
        out2.append(num)
        out3.append(ttl_count_in_bin/num)
    return [out1, out2, out3]

if int(sys.argv[1]) == -1:
    data_list = ['heart_scale']
elif int(sys.argv[1]) == 0:
    data_list = ['rcv1_test']
else:
    data_list = ['kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'splice_site_t_0_1', 'rcv1_test']

data_path = {
    'heart_scale':'./heart_scale-1-log-5.updates.nnz.sorted',\
    'avazu-app':'./avazu-app-1-log-5.updates.nnz.sorted',\
    'criteo':'criteo-1-log-5.updates.nnz.sorted',\
    'kdda':'kdda-1-log-5.updates.nnz.sorted',\
    'kdd12':'kdd12-1-log-5.updates.nnz.sorted',\
    'url':'url-1-log-5.updates.nnz.sorted',\
    'higgs':'higgs-1-log-5.updates.nnz.sorted',\
    'web':'web_trigram-1-log-5.updates.nnz.sorted',
    'rcv1_test':'rcv1_test-1-log-5.updates.nnz.sorted',\
    'splice':'split_site_t_0_1-1-log-5.updates.nnz.sorted',\
    'yk':'yk-1-log-5.updates.nnz.sorted'
}

data_mapping = {
    'heart_scale':'heart\_scale',\
    'avazu-app':'\\avazuapp',\
    'avazu-site':'\\avazusite',\
    'criteo':'\\criteo',\
    'kdda':'\\kdda',\
    'kdd12':'\\kddtwelve',\
    'url':'\\urlcombined',\
    'web':'\\webspam',\
    'rcv1_test':'\\rcvone',\
    'splice':'\\splice',\
    'yk':'\\yk',\
}


num_bin = int(sys.argv[2])
for data in data_list:
    input_path = data_path[data]
    res = binning(input_path, num_bin)
    print_tex(data, res)
