#!/bin/bash
exp=-1

mkdir log

##prepare data
cd ./data
./prepare_data.py $exp
cd ..

#compile all experimental codes
./clean_compile_files.sh
./compile_files.sh
#
# Table 1
python2 ./generate_table1_step1_get_stats.py $exp
python2 ./generate_table1_step2_get_percentile.py $exp
python2 ./generate_table1_step3_final.py $exp > table1

# Table 3&4
python2 ./generate_table3and4.py $exp
python2 ./generate_table3_final.py $exp > table3

#
# Table 5
python2 ./check_nnza_nnzb.py $exp
python2 ./draw_updates_nnz.py $exp
python2 ./generate_table5.py $exp 10 > table5

#Table 6
python2 ./generate_table6.py $exp
python2 ./generate_table6_final.py $exp > table6

mkdir ./bcdn_supp_log
# Generate tables and figures in supplementary materials
python2 ./generate_supp_TableI.py $exp
python2 generate_supp_tableI.py $exp > supp_tableI
./generate_supp_TableII.sh 
./generate_supp_FigureIa_TableIIIa_TableVa.sh
./generate_supp_FigureIb_TableIIIb.sh
./generate_supp_FigureII_TableIV_TableVb.sh

./generate_supp_tableIII.py > tableIII

matlab -nodisplay -r "draw_supp_fig1a"
matlab -nodisplay -r "draw_supp_fig1b"
matlab -nodisplay -r "draw_supp_fig2"
matlab -nodisplay -r "draw_supp_fig3"
